Index: code/trunk/src/network/packet/Acknowledgement.h
===================================================================
--- code/trunk/src/network/packet/Acknowledgement.h	(revision 1735)
+++ code/trunk/src/network/packet/Acknowledgement.h	(revision 1735)
@@ -0,0 +1,56 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Oliver Scheuss <scheusso [at] ee.ethz.ch>, (C) 2008
+ *   Co-authors:
+ *      ...
+ *
+ */
+#ifndef NETWORKACKNOLEDGEMENT_H
+#define NETWORKACKNOLEDGEMENT_H
+
+#include "Packet.h"
+
+
+namespace network {
+namespace packet {
+/**
+	@author 
+*/
+class Acknowledgement : public Packet
+{
+public:
+  Acknowledgement( unsigned int id, int clientID );
+  Acknowledgement( unsigned char* data, int clientID );
+  ~Acknowledgement();
+  
+  inline unsigned int getSize() const;
+  bool process();
+  
+  unsigned int getAckID();
+private:
+};
+
+} //namespace packet
+} //namespace network
+
+#endif
Index: code/trunk/src/network/packet/Chat.cc
===================================================================
--- code/trunk/src/network/packet/Chat.cc	(revision 1735)
+++ code/trunk/src/network/packet/Chat.cc	(revision 1735)
@@ -0,0 +1,78 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Oliver Scheuss <scheusso [at] ee.ethz.ch>, (C) 2008
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#include "Chat.h"
+#include <assert.h>
+
+namespace network {
+namespace packet {
+  
+#define PACKET_FLAGS_CHAT ENET_PACKET_FLAG_RELIABLE
+#define _PACKETID         0
+#define _MESSAGELENGTH    _PACKETID + sizeof(ENUM::Type)
+#define _MESSAGE          _MESSAGELENGTH + sizeof(unsigned int)
+
+Chat::Chat( std::string& message, int clientID )
+ : Packet()
+{
+  flags_ = flags_ | PACKET_FLAGS_CHAT;
+  messageLength_ = message.length()+1;
+  data_=new unsigned char[ getSize() ];
+  *(ENUM::Type *)&data_[ _PACKETID ] = ENUM::Chat;
+  *(unsigned int *)&data_[ _MESSAGELENGTH ] = messageLength_;
+  memcpy( &data_[ _MESSAGE ], (void *)message.c_str(), messageLength_ );
+  clientID_=clientID;
+}
+
+Chat::Chat( unsigned char *data, int clientID )
+  : Packet(data, clientID)
+{
+  messageLength_ = *(unsigned int *)&data[ _MESSAGELENGTH ];
+}
+
+Chat::~Chat()
+{
+}
+
+unsigned int Chat::getSize() const{
+  return _MESSAGE + messageLength_;
+}
+
+bool Chat::process(){
+  //TODO: change this !!!
+  assert(0);
+  delete this;
+  return true;
+}
+
+unsigned char *Chat::getMessage(){
+  return &data_[ _MESSAGE ];
+}
+
+} //namespace packet
+} //namespace network
Index: code/trunk/src/network/packet/Chat.h
===================================================================
--- code/trunk/src/network/packet/Chat.h	(revision 1735)
+++ code/trunk/src/network/packet/Chat.h	(revision 1735)
@@ -0,0 +1,34 @@
+
+#ifndef NETWORKCHAT_H
+#define NETWORKCHAT_H
+
+#include <string>
+
+#include "Packet.h"
+
+namespace network {
+namespace packet {
+/**
+	@author 
+*/
+class Chat : public Packet
+{
+public:
+  Chat( std::string& message, int clientID );
+  Chat( unsigned char* data, int clientID );
+  ~Chat();
+  
+  inline unsigned int getSize() const;
+  bool process();
+  
+  unsigned int getMessageLength(){ return messageLength_; };
+  unsigned char *getMessage();
+private:
+  unsigned int messageLength_;
+  int clientID_;
+};
+
+} //namespace packet
+} //namespace network
+
+#endif
Index: code/trunk/src/network/packet/ClassID.cc
===================================================================
--- code/trunk/src/network/packet/ClassID.cc	(revision 1735)
+++ code/trunk/src/network/packet/ClassID.cc	(revision 1735)
@@ -0,0 +1,88 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Oliver Scheuss, (C) 2008
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+
+
+#include "ClassID.h"
+#include "core/CoreIncludes.h"
+#include <string>
+#include <assert.h>
+
+namespace network {
+namespace packet {
+
+#define PACKET_FLAGS_CLASSID  ENET_PACKET_FLAG_RELIABLE
+#define _PACKETID             0
+#define _CLASSID              _PACKETID + sizeof(ENUM::Type)
+#define _CLASSNAMELENGTH      _CLASSID + sizeof(unsigned int)
+#define _CLASSNAME            _CLASSNAMELENGTH + sizeof(classNameLength_)
+  
+  ClassID::ClassID( unsigned int classID, std::string className )
+ : Packet()
+{
+  flags_ = flags_ | PACKET_FLAGS_CLASSID;
+  classNameLength_=className.length()+1;
+  assert(getSize());
+  data_=new unsigned char[ getSize() ];
+  assert(data_);
+  *(ENUM::Type *)(data_ + _PACKETID ) = ENUM::ClassID;
+  *(unsigned int *)(data_ + _CLASSID ) = classID;
+  *(unsigned int *)(data_ + _CLASSNAMELENGTH ) = classNameLength_;
+  memcpy( data_+_CLASSNAME, (void *)className.c_str(), classNameLength_ );
+}
+
+ClassID::ClassID( unsigned char *data, int clientID )
+  : Packet(data, clientID)
+{
+  memcpy( (void *)&classNameLength_, &data[ _CLASSNAMELENGTH ], sizeof(classNameLength_) );
+}
+
+ClassID::~ClassID()
+{
+}
+
+unsigned int ClassID::getSize() const{
+  return sizeof(network::packet::ENUM::Type) + 2*sizeof(unsigned int) + classNameLength_;
+}
+
+bool ClassID::process(){
+  COUT(3) << "processing classid: " << getClassID() << " name: " << (const char*)(data_+_CLASSNAME) << std::endl;
+  orxonox::Identifier *id=ID( std::string((const char*)(data_+_CLASSNAME) ));
+  if(id==NULL)
+    return false;
+  id->setNetworkID( getClassID() );
+  delete this;
+  return true;
+}
+
+unsigned int ClassID::getClassID(){
+  return *(unsigned int *)&data_[ _CLASSID ];
+}
+
+} //namespace packet
+}//namespace network
Index: code/trunk/src/network/packet/ClassID.h
===================================================================
--- code/trunk/src/network/packet/ClassID.h	(revision 1735)
+++ code/trunk/src/network/packet/ClassID.h	(revision 1735)
@@ -0,0 +1,61 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Oliver Scheuss <scheusso [at] ee.ethz.ch>, (C) 2008
+ *   Co-authors:
+ *      ...
+ *
+ */
+#ifndef NETWORKCLASSID_H
+#define NETWORKCLASSID_H
+
+#include <string>
+
+#include "Packet.h"
+
+namespace network {
+namespace packet {
+
+/**
+	@author 
+*/
+class ClassID : public Packet
+{
+public:
+  ClassID( unsigned int classID, std::string className );
+  ClassID( unsigned char* data, int clientID );
+  ~ClassID();
+  
+  inline unsigned int getSize() const;
+  bool process();
+  
+  unsigned int getClassID();
+  unsigned int getClassNameLength(){ return classNameLength_; }
+  unsigned char *getClassName();
+private:
+  unsigned int classNameLength_;
+};
+
+} //namespace packet
+} //namespace network
+
+#endif
Index: code/trunk/src/network/packet/Gamestate.cc
===================================================================
--- code/trunk/src/network/packet/Gamestate.cc	(revision 1735)
+++ code/trunk/src/network/packet/Gamestate.cc	(revision 1735)
@@ -0,0 +1,348 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Oliver Scheuss, (C) 2008
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#include "Gamestate.h"
+#include "network/ClientInformation.h"
+#include "network/GamestateHandler.h"
+
+#include <zlib.h>
+#include <assert.h>
+
+
+
+namespace network {
+
+namespace packet {
+  
+
+#define GAMESTATE_START(data) data + sizeof(GamestateHeader)
+#define GAMESTATE_HEADER(data) ((GamestateHeader *)data)
+#define HEADER GAMESTATE_HEADER(data_)
+  
+Gamestate::Gamestate()
+{
+}
+
+Gamestate::Gamestate(unsigned char *data, int clientID):
+    Packet(data, clientID)
+{
+}
+
+
+Gamestate::~Gamestate()
+{
+}
+
+bool Gamestate::collectData(int id, int mode)
+{
+  int tempsize=0, currentsize=0;
+  assert(data_==0 /*&& bs_==0*/);
+  int size = calcGamestateSize(mode);
+  
+  COUT(4) << "G.ST.Man: producing gamestate with id: " << id << std::endl;
+    //retval->data = (unsigned char*)malloc(size);
+  if(size==0)
+    return false;
+  data_ = new unsigned char[size + sizeof(GamestateHeader)];
+  //bs_ = new Bytestream(data_+sizeof(GamestateHeader), size);
+  if(!data_){
+    COUT(2) << "GameStateManager: could not allocate memory" << std::endl;
+    return false;
+  }
+
+  //start collect data synchronisable by synchronisable
+  unsigned char *mem=data_;
+  mem+=sizeof(GamestateHeader);
+  orxonox::Iterator<Synchronisable> it;
+  for(it = orxonox::ObjectList<Synchronisable>::start(); it; ++it){
+    tempsize=it->getSize2(mode);
+    
+    if(currentsize+tempsize > size){
+      // start allocate additional memory
+      COUT(3) << "G.St.Man: need additional memory" << std::endl;
+      orxonox::Iterator<Synchronisable> temp = it;
+      int addsize=tempsize;
+      while(++temp)
+        addsize+=temp->getSize2(mode);
+      data_ = (unsigned char *)realloc(data_, sizeof(GamestateHeader) + currentsize + addsize);
+      if(!data_)
+        return false;
+      size = currentsize+addsize;
+    }// stop allocate additional memory
+
+    if(!it->getData2(mem, mode))
+      return false; // mem pointer gets automatically increased because of call by reference
+    // increase size counter by size of current synchronisable
+    currentsize+=tempsize;
+  }
+  
+  
+  //start write gamestate header
+  HEADER->packetType = ENUM::Gamestate;
+  assert( *(ENUM::Type *)(data_) == ENUM::Gamestate); 
+  HEADER->normsize = currentsize;
+  HEADER->id = id;
+  HEADER->diffed = false;
+  HEADER->complete = true;
+  HEADER->compressed = false;
+  //stop write gamestate header
+  
+  COUT(5) << "G.ST.Man: Gamestate size: " << currentsize << std::endl;
+  COUT(5) << "G.ST.Man: 'estimated' (and corrected) Gamestate size: " << size << std::endl;
+  return true;
+}
+
+bool Gamestate::spreadData(int mode)
+{
+  assert(data_ && !HEADER->compressed && !HEADER->diffed);
+  unsigned int size, objectID, classID;
+  unsigned char *mem=data_+sizeof(GamestateHeader);
+    // get the start of the Synchronisable list
+  orxonox::Iterator<Synchronisable> it=orxonox::ObjectList<Synchronisable>::start();
+  
+  while(mem < data_+sizeof(GamestateHeader)+HEADER->normsize){
+      // extract synchronisable header
+    size = *(unsigned int *)mem;
+    objectID = *(unsigned int*)(mem+sizeof(unsigned int));
+    classID = *(unsigned int*)(mem+2*sizeof(unsigned int));
+
+    if(!it || it->objectID!=objectID || it->classID!=classID){
+        // bad luck ;)
+        // delete the synchronisable (obviously seems to be deleted on the server)
+      while(it && it->objectID!=objectID)
+        removeObject(it);
+
+      if(!it){
+        //fabricate the new synchronisable
+        if(!Synchronisable::fabricate(mem, mode))
+          /*return false*/;
+        it=orxonox::ObjectList<Synchronisable>::end();
+      }
+    } else 
+    {
+        // we have our object
+      if(! it->updateData(mem, mode))
+      {
+        COUT(1) << "We couldn't update objectID: " \
+            << objectID << "; classID: " << classID << std::endl;
+      }
+    }
+    ++it;
+  }
+
+  return true;
+}
+
+int Gamestate::getID(){
+  return HEADER->id;
+}
+
+unsigned int Gamestate::getSize() const
+{
+  assert(data_);
+  if(HEADER->compressed)
+    return HEADER->compsize+sizeof(GamestateHeader);
+  else
+  {
+    return HEADER->normsize+sizeof(GamestateHeader);
+  }
+}
+
+bool Gamestate::process()
+{
+  return GamestateHandler::addGamestate(this, getClientID());
+}
+
+bool Gamestate::compressData()
+{
+  assert(HEADER);
+  uLongf buffer = (uLongf)((HEADER->normsize + 12)*1.01)+1;
+  if(buffer==0)
+    return false;
+  
+  unsigned char *ndata = new unsigned char[buffer+sizeof(GamestateHeader)];
+  unsigned char *dest = GAMESTATE_START(ndata);
+  int retval;
+  retval = compress( dest, &buffer, GAMESTATE_START(data_), (uLong)(HEADER->normsize) );
+  switch ( retval ) {
+    case Z_OK: COUT(5) << "G.St.Man: compress: successfully compressed" << std::endl; break;
+    case Z_MEM_ERROR: COUT(1) << "G.St.Man: compress: not enough memory available in gamestate.compress" << std::endl; 
+    return false;
+    case Z_BUF_ERROR: COUT(2) << "G.St.Man: compress: not enough memory available in the buffer in gamestate.compress" << std::endl;
+    return false;
+    case Z_DATA_ERROR: COUT(2) << "G.St.Man: compress: data corrupted in gamestate.compress" << std::endl;
+    return false;
+  }
+
+  //copy and modify header
+  HEADER->compsize = buffer;
+  HEADER->compressed = true;
+  *GAMESTATE_HEADER(ndata) = *HEADER;
+  //delete old data
+  delete[] data_;
+  //save new data
+  data_ = ndata;
+  assert(HEADER->compressed);
+  COUT(3) << "gamestate compress normsize: " << HEADER->normsize << " compsize: " << HEADER->compsize << std::endl;
+  return true;
+}
+bool Gamestate::decompressData()
+{
+  assert(HEADER->compressed);
+  //COUT(4) << "GameStateClient: uncompressing gamestate. id: " << a->id << ", baseid: " << a->base_id << ", normsize: " << a->normsize << ", compsize: " << a->compsize << std::endl;
+  int normsize = HEADER->normsize;
+  int compsize = HEADER->compsize;
+  int bufsize;
+  if(normsize < compsize)
+    bufsize = compsize;
+  else
+    bufsize = normsize;
+  if(bufsize==0)
+    return NULL;
+  unsigned char *ndata = new unsigned char[bufsize + sizeof(GamestateHeader)];
+  unsigned char *dest = ndata + sizeof(GamestateHeader);
+  int retval;
+  uLongf length=normsize;
+  retval = uncompress( dest, &length, data_+sizeof(GamestateHeader), (uLong)compsize );
+  switch ( retval ) {
+    case Z_OK: COUT(5) << "successfully decompressed" << std::endl; break;
+    case Z_MEM_ERROR: COUT(1) << "not enough memory available" << std::endl; return false;
+    case Z_BUF_ERROR: COUT(2) << "not enough memory available in the buffer" << std::endl; return false;
+    case Z_DATA_ERROR: COUT(2) << "data corrupted (zlib)" << std::endl; return false;
+  }
+  
+  HEADER->compressed = false;
+  //copy over the header
+  *GAMESTATE_HEADER(ndata) = *HEADER;
+  //delete old (compressed data)
+  delete[] data_;
+  //set new pointers and create bytestream
+  data_ = ndata;
+  //bs_ = new Bytestream(getGs(), GAMESTATE_HEADER->normsize);
+  
+  return true;
+}
+
+Gamestate *Gamestate::diff(Gamestate *base)
+{
+  //unsigned char *basep = base->getGs()/*, *gs = getGs()*/;
+  unsigned char *basep = GAMESTATE_START(base->data_), *gs = GAMESTATE_START(this->data_);
+  unsigned int of=0; // pointers offset
+  unsigned int dest_length=0;
+  dest_length=HEADER->normsize;
+  if(dest_length==0)
+    return NULL;
+  unsigned char *ndata = new unsigned char[dest_length*sizeof(unsigned char)+sizeof(GamestateHeader)];
+  unsigned char *dest = ndata + sizeof(GamestateHeader);
+  while(of < GAMESTATE_HEADER(base->data_)->normsize && of < HEADER->normsize){
+    *(dest+of)=*(basep+of)^*(gs+of); // do the xor
+    ++of;
+  }
+  if(GAMESTATE_HEADER(base->data_)->normsize!=HEADER->normsize){
+    unsigned char n=0;
+    if(GAMESTATE_HEADER(base->data_)->normsize < HEADER->normsize){
+      while(of<dest_length){
+        *(dest+of)=n^*(gs+of);
+        of++;
+      }
+    }
+  }
+
+  *GAMESTATE_HEADER(ndata) = *HEADER;
+  GAMESTATE_HEADER(ndata)->diffed = true;
+  Gamestate *g = new Gamestate(ndata, 0);
+  return g;
+}
+
+Gamestate *Gamestate::undiff(Gamestate *base)
+{
+  assert(this && base);
+  assert(!HEADER->compressed && !GAMESTATE_HEADER(base->data_)->compressed);
+  //unsigned char *basep = base->getGs()/*, *gs = getGs()*/;
+  unsigned char *basep = GAMESTATE_START(base->data_);
+  unsigned char *gs = GAMESTATE_START(this->data_);
+  unsigned int of=0; // pointers offset
+  unsigned int dest_length=0;
+  dest_length=HEADER->normsize;
+  if(dest_length==0)
+    return NULL;
+  unsigned char *ndata = new unsigned char[dest_length*sizeof(unsigned char)+sizeof(GamestateHeader)];
+  unsigned char *dest = ndata + sizeof(GamestateHeader);
+  while(of < GAMESTATE_HEADER(base->data_)->normsize && of < HEADER->normsize){
+    *(dest+of)=*(basep+of)^*(gs+of); // do the xor
+    ++of;
+  }
+  if(GAMESTATE_HEADER(base->data_)->normsize!=HEADER->normsize){
+    unsigned char n=0;
+    if(GAMESTATE_HEADER(base->data_)->normsize < HEADER->normsize){
+      while(of < dest_length){
+        *(dest+of)=n^*(gs+of);
+        of++;
+      }
+    }
+  }
+  *GAMESTATE_HEADER(ndata) = *HEADER;
+  GAMESTATE_HEADER(ndata)->diffed = false;
+  Gamestate *g = new Gamestate(ndata, 0);
+  return g;
+}
+
+
+unsigned int Gamestate::calcGamestateSize(int mode)
+{
+  int size=0;
+    // get the start of the Synchronisable list
+  orxonox::Iterator<Synchronisable> it;
+    // get total size of gamestate
+  for(it = orxonox::ObjectList<Synchronisable>::start(); it; ++it)
+    size+=it->getSize2(mode); // size of the actual data of the synchronisable
+//  size+=sizeof(GamestateHeader);
+  return size;
+}
+
+/**
+ * This function removes a Synchronisable out of the universe
+ * @param it iterator of the list pointing to the object
+ * @return iterator pointing to the next object in the list
+ */
+  void Gamestate::removeObject(orxonox::Iterator<Synchronisable> &it) {
+    orxonox::Iterator<Synchronisable> temp=it;
+    ++it;
+    delete  *temp;
+  }
+
+  bool Gamestate::isDiffed(){
+    return HEADER->diffed;
+  }
+  
+  int Gamestate::getBaseID(){
+    return HEADER->base_id;
+  }
+}
+
+}
Index: code/trunk/src/network/packet/Gamestate.h
===================================================================
--- code/trunk/src/network/packet/Gamestate.h	(revision 1735)
+++ code/trunk/src/network/packet/Gamestate.h	(revision 1735)
@@ -0,0 +1,90 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Oliver Scheuss, (C) 2008
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#include "Packet.h"
+#include "network/Synchronisable.h"
+//#include "util/Bytestream.h"
+#include "core/CoreIncludes.h"
+
+#ifndef NETWORK_PACKETGAMESTATE_H
+#define NETWORK_PACKETGAMESTATE_H
+
+namespace network {
+
+namespace packet {
+  
+struct GamestateHeader{
+  ENUM::Type packetType;
+  int id; // id of the gamestate
+  unsigned int compsize;
+  unsigned int normsize;
+  int base_id; // id of the base-gamestate diffed from
+  bool diffed; // wheter diffed or not
+  bool complete; // wheter it is a complete gamestate or only partial
+  bool compressed;
+};
+
+/**
+	@author 
+*/
+class Gamestate: public Packet{
+  public:
+    Gamestate();
+    Gamestate(unsigned char *data, int clientID);
+    
+    ~Gamestate();
+    
+    bool collectData(int id, int mode=0x0);
+    bool spreadData(int mode=0x0);
+    int getID();
+    bool isDiffed();
+    int getBaseID();
+    Gamestate *diff(Gamestate *base);
+    Gamestate *undiff(Gamestate *base);
+    bool compressData();
+    bool decompressData();
+    
+    // Packet functions
+    virtual unsigned int getSize() const;
+    virtual bool process();
+
+    
+  private:
+    unsigned int calcGamestateSize(int mode=0x0);
+    void removeObject(orxonox::Iterator<Synchronisable> &it);
+
+    
+    //Bytestream *bs_;
+    //GamestateHeader *header_;
+};
+
+}
+
+}
+
+#endif
Index: code/trunk/src/network/packet/Packet.cc
===================================================================
--- code/trunk/src/network/packet/Packet.cc	(revision 1735)
+++ code/trunk/src/network/packet/Packet.cc	(revision 1735)
@@ -0,0 +1,176 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Oliver Scheuss, (C) 2008
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+
+#include <enet/enet.h>
+#include <boost/bind.hpp>
+
+#include "Packet.h"
+#include "network/ConnectionManager.h"
+#include "network/ClientInformation.h"
+
+#include "Acknowledgement.h"
+#include "Chat.h"
+#include "ClassID.h"
+#include "Gamestate.h"
+#include "Welcome.h"
+#include "network/Host.h"
+#include "core/CoreIncludes.h"
+
+namespace network{
+
+namespace packet{
+  
+#define PACKET_FLAG_DEFAULT ENET_PACKET_FLAG_NO_ALLOCATE
+#define _PACKETID           0
+  
+std::map<ENetPacket *, Packet *> Packet::packetMap_;
+  
+Packet::Packet(){
+  flags_ = PACKET_FLAG_DEFAULT;
+  packetDirection_ = ENUM::Outgoing;
+  clientID_=0;
+  data_=0;
+  enetPacket_=0;
+}
+
+void blub(ENetPacket *packet){
+  COUT(4) << "blubb" << std::endl;
+}
+
+Packet::Packet(unsigned char *data, int clientID){
+  flags_ = PACKET_FLAG_DEFAULT;
+  packetDirection_ = ENUM::Incoming;
+  clientID_=clientID;
+  data_=data;
+  enetPacket_=0;
+}
+
+/*Packet::Packet(ENetPacket *packet, ENetPeer *peer){
+  packetDirection_ = ENUM::Incoming;
+  enetPacket_ = packet;
+  clientID_ = ClientInformation::findClient(&peer->address)->getID();
+  data_ = packet->data;
+}*/
+
+Packet::Packet(const Packet &p){
+  enetPacket_=p.enetPacket_;
+  flags_=p.flags_;
+  packetDirection_ = p.packetDirection_;
+  clientID_ = p.clientID_;
+  if(p.data_){
+    data_ = new unsigned char[p.getSize()];
+    memcpy(data_, p.data_, p.getSize());
+  }else
+    data_=0;
+}
+
+Packet::~Packet(){
+  if(enetPacket_)
+    enet_packet_destroy(enetPacket_);
+  if(data_)
+    delete[] data_;
+}
+
+bool Packet::send(){
+  if(packetDirection_ != ENUM::Outgoing && packetDirection_ != ENUM::Bidirectional ){
+    assert(0);
+    return false;
+  }
+  if(!enetPacket_){
+    if(!data_){
+      assert(0);
+      return false;
+    }
+    enetPacket_ = enet_packet_create(getData(), getSize(), getFlags());
+    //enetPacket_->freeCallback = &Packet::deletePacket;
+    enetPacket_->freeCallback = &blub;
+    packetMap_[enetPacket_] = this;
+  }
+  /*switch( *(ENUM::Type *)(data_ + _PACKETID) )
+  {
+    case ENUM::Acknowledgement:
+    case ENUM::Chat:
+    case ENUM::ClassID:
+    case ENUM::Gamestate:
+    case ENUM::Welcome:
+      COUT(3) << "welcome" << std::endl;
+      p = new Welcome( data, clientID );
+    default:
+      assert(0); //TODO: repair this
+      break;
+  }*/
+  network::Host::addPacket( enetPacket_, clientID_);
+  enetPacket_ = 0; // otherwise we have a double free because enet already handles the deallocation of the packet
+  return true;
+}
+
+Packet *Packet::createPacket(ENetPacket *packet, ENetPeer *peer){
+  unsigned char *data = packet->data;
+  unsigned int clientID = ClientInformation::findClient(&peer->address)->getID();
+  Packet *p;
+  COUT(3) << "packet type: " << *(ENUM::Type *)&data[_PACKETID] << std::endl;
+  switch( *(ENUM::Type *)(data + _PACKETID) )
+  {
+    case ENUM::Acknowledgement:
+      COUT(3) << "ack" << std::endl;
+      p = new Acknowledgement( data, clientID );
+      break;
+    case ENUM::Chat:
+      COUT(3) << "chat" << std::endl;
+      p = new Chat( data, clientID );
+      break;
+    case ENUM::ClassID:
+      COUT(3) << "classid" << std::endl;
+      p = new ClassID( data, clientID );
+      break;
+    case ENUM::Gamestate:
+      COUT(3) << "gamestate" << std::endl;
+      // TODO: remove brackets
+      p = new Gamestate( data, clientID );
+      break;
+    case ENUM::Welcome:
+      COUT(3) << "welcome" << std::endl;
+      p = new Welcome( data, clientID );
+      break;
+    default:
+      assert(0); //TODO: repair this
+      break;
+  }
+  return p;
+}
+
+void Packet::deletePacket(ENetPacket *packet){
+  assert(packetMap_[packet]);
+  delete packetMap_[packet];
+}
+
+} // namespace packet
+
+} // namespace network
+
Index: code/trunk/src/network/packet/Packet.h
===================================================================
--- code/trunk/src/network/packet/Packet.h	(revision 1735)
+++ code/trunk/src/network/packet/Packet.h	(revision 1735)
@@ -0,0 +1,91 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Oliver Scheuss <scheusso [at] ee.ethz.ch>, (C) 2008
+ *   Co-authors:
+ *      ...
+ *
+ */
+#ifndef NETWORKPACKET_H
+#define NETWORKPACKET_H
+
+#include <map>
+#include <enet/enet.h>
+
+namespace network {
+
+namespace packet{
+  
+namespace ENUM{
+  enum Direction{
+    Incoming,
+    Outgoing,
+    Bidirectional
+  };
+  enum Type{
+    Acknowledgement,
+    Gamestate,
+    ClassID,
+    Chat,
+    Welcome
+  };
+}
+  
+/**
+	@author Oliver Scheuss <scheusso [at] ee.ethz.ch>
+*/
+class Packet{
+  public:
+    Packet(const Packet &p);
+    virtual ~Packet();
+    static Packet *createPacket(ENetPacket *packet, ENetPeer *peer);
+    static void deletePacket(ENetPacket *packet);
+    
+    virtual unsigned char *getData(){ return data_; };
+    virtual unsigned int getSize() const =0;
+    virtual bool process()=0;
+    enet_uint32 getFlags()
+      { return flags_; }
+    int getClientID()
+      { return clientID_; }
+    void setClientID( int id )
+      { clientID_ = id; }
+    
+    bool send();
+  protected:
+    Packet();
+    Packet(unsigned char *data, int clientID);
+//    Packet(ENetPacket *packet, ENetPeer *peer);
+    enet_uint32 flags_;
+    int clientID_;
+    unsigned char *data_;
+  private:
+    static std::map<ENetPacket *, Packet *> packetMap_;
+    ENetPacket *enetPacket_;
+    ENUM::Direction packetDirection_;
+};
+
+} //namespace packet
+
+} //namespace network
+
+#endif
